package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmBrandHonorInfo;
import com.zksy.system.basicData.service.CrmBrandHonorInfoService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 品牌荣誉信息Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmBrandHonorInfo")
@Api(tags = "品牌荣誉信息", description = "品牌荣誉信息desc")
public class CrmBrandHonorInfoController extends BaseController{

    @Autowired
    private CrmBrandHonorInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "品牌荣誉信息搜索getById")
    public CrmBrandHonorInfo getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "品牌荣誉信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "品牌荣誉信息查询所有")
    public List<CrmBrandHonorInfo> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增品牌荣誉信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "品牌荣誉信息新增")
    @Log(title = "新增品牌荣誉信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmBrandHonorInfo crmBrandHonorInfo) {
        return service.save(crmBrandHonorInfo);
    }

    /**
     * 修改品牌荣誉信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "品牌荣誉信息修改")
    @Log(title = "修改品牌荣誉信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmBrandHonorInfo crmBrandHonorInfo) {
        return service.updateById(crmBrandHonorInfo);
    }

    /**
     * 导入品牌荣誉信息
     */
    @ApiOperation("品牌荣誉信息导入")
    @Log(title = "品牌荣誉信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmBrandHonorInfo> crmBrandHonorInfoAll = service.list();
            List<CrmBrandHonorInfo> list = ExcelUtils.readMultipartFile(file, CrmBrandHonorInfo.class,CrmBrandHonorInfo.class.getDeclaredFields().length - 2);
            if(crmBrandHonorInfoAll != null && crmBrandHonorInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("品牌荣誉信息导出")
    @Log(title = "品牌荣誉信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmBrandHonorInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"品牌荣誉信息",wrapperList,CrmBrandHonorInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "品牌荣誉信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除品牌荣誉信息", notes = "删除品牌荣誉信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"品牌荣誉信息模板");
    }
}

